<?php

namespace App\Console;

use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;
use App\Http\Controllers\MailController;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        //
        //Commands\ConsoleTest::class
        Commands\UserMetafield::class,
        Commands\QuizCron::class,
        Commands\AbandonedCart::class,
        Commands\ShipmentDeliveryTracking::class

    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
                     
        $schedule->command('quiz:abandoned')
                 ->hourly()
        //  ->withoutOverlapping(); 
                ->runInBackground();
                 
        $schedule->command('user:metafield')
                 ->everyMinute()
       //  ->withoutOverlapping()
                 ->runInBackground();
        $schedule->command('abandoned:cart')
                 ->everyMinute();
                 
        $schedule->command('shipmentDelivery:tracking')
                ->dailyAt('02:15')
                ->timezone('America/Los_Angeles')
                ->runInBackground();
        $schedule->command('shipmentDelivery:tracking')
                ->dailyAt('09:15')
                ->timezone('America/Los_Angeles')
                ->runInBackground();
        $schedule->command('shipmentDelivery:tracking')
                ->dailyAt('12:15')
                ->timezone('America/Los_Angeles')
                ->runInBackground();
        $schedule->command('subscription:discount')
                ->dailyAt('03:00')
                ->timezone('America/Los_Angeles')
                ->runInBackground();
        $schedule->command('subscription:metaUpdate')
                ->dailyAt('00:00')
                ->timezone('America/Los_Angeles')
                ->runInBackground();  

        // $schedule->command('giftPack:eventCreation')
        //         ->dailyAt('08:00')
        //         ->timezone('America/Los_Angeles')
        //         ->withoutOverlapping()
        //         ->runInBackground();

        // $schedule->command('giftPack:eventCreation')
        //         ->dailyAt('12:00')
        //         ->timezone('America/Los_Angeles')
        //         ->withoutOverlapping()
        //         ->runInBackground();

        // $schedule->command('giftPack:eventCreation')
        //         ->dailyAt('16:00')
        //         ->timezone('America/Los_Angeles')
        //         ->withoutOverlapping()
        //         ->runInBackground();

        $schedule->command('giftPack:eventCreation')
                ->dailyAt('21:00')
                ->timezone('America/Los_Angeles')
                ->withoutOverlapping()
                ->runInBackground();

        $schedule->command('ePcUrl:ePcUrlInvoke')
                ->everyThirtyMinutes()
                ->timezone('America/Los_Angeles')
                ->withoutOverlapping()
                ->runInBackground();

        $schedule->command('upcomingCharge:validityChecking')
                ->dailyAt('20:00')
                ->timezone('America/Los_Angeles')
                ->runInBackground();
    }

    /**
     * Register the commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        $this->load(__DIR__.'/Commands');

        require base_path('routes/console.php');
    }
}
