<?php
namespace App\Model;
use Illuminate\Database\Eloquent\Model;

class dataPostInternal extends Model {


    private $nurishRerouteInternalUrl = '';
    private $epcInternalUrl = '';
    private $quizCartOffLoadInternalUrl = '';

    function __construct() {

        $this->nurishRerouteInternalUrl = env('REROUTE_INTERNAL_URL', true);
        $this->epcInternalUrl = env('EPC_INTERNAL_URL', true);
        $this->quizCartOffLoadInternalUrl = env('QUIZ_CART_OFFLOAD_URL', true);
    }

    /**
     * Nurish order reroute request post function
     */
    public function postRerouteOrderDetailsToNurish($data) {

        $method = 'POST';
        $path = $this->nurishRerouteInternalUrl;
        $response = $this->call($method, $path, $data);
        return json_decode($response);
    }

    /**
     * Call ePC nurish internal URL
     */
    public function invokeEpcApiUrl() {

        $method = 'GET';
        $path = $this->epcInternalUrl;
        $response = $this->call($method, $path);
        return json_decode($response);
    }

    /**
     * Nurish post cart data to an internal URL
     */
    public function postQuizCartOffLoadData($data) {

        $method = 'POST';
        $path = $this->quizCartOffLoadInternalUrl;
        $response = $this->call($method, $path, $data);
        return $response;
    }

    /**
     * CURL call
     */
    function call($method, $path, $data = []) {

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $path);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_ENCODING, '');
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        curl_setopt($curl, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);

        if ($method !== 'GET') {

            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }

        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            "content-type: application/json",
        ));

        $response = curl_exec($curl);
        return $response;
    }


}
